<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib ("polls", "categories");

	require_once GEKKO_ROOT."lib/auth.inc.php";

	varImport("action", "id", "return");

	function polls_validateOptions(&$opt) {
		$opts = 0;
		while (list($i) = each($opt))
			$opts += trim($opt[$i]) ? 1 : 0;

		// needs at least two options
		if ($opts < 2)
			abort(_l("E_INSUFFICIENT_DATA"));
		return true;
	}

	switch ($action) {
		case "vote":

			varImport("option");

			requireVars("option");

			$db->query("SELECT pollid FROM ".db_table("polls_option")."
			WHERE id='{$option}' AND description <> ''", __FILE__, __LINE__);

			if ($db->num_rows()) {

				$row = $db->fetch_row();

				$db->query("SELECT id, category FROM ".db_table("polls")."
				WHERE id='{$row["pollid"]}' AND status='1'", __FILE__, __LINE__);

				if ($db->num_rows()) {

					$row = $db->fetch_row();

					if (polls::alreadyVoted($row["id"])) {

						$return = urlEvalPrototype("index.php/module=polls/action=view?id={$id}&message=".urlencode(_l("L_ALREADY_VOTED")), true, false);

					} else {

						if (categories::auth($row["category"])) {

							polls::registerVote($row["id"]);

							$db->query("UPDATE ".db_table("polls_option")." SET
							votes = votes + 1
							WHERE id = '{$option}'",
							__FILE__, __LINE__);

							slog("polls: vote registered in pool (id='$id') for option (id='$option').", 3);

						} else {
							abort(accessDenied());
						}

					}
				}
			}
		break;
	}

	if (is_admin()) {
		switch ($action) {
			case "createblock":

				varRequire("id");

				LoadLib ("blocks");

				$block_id = Blocks::simpleCreate(_l("L_POLL"), "", "polls/show.php", "id={$id}", "polls.png");

				$return = urlEvalPrototype("index.php/module=admin/base=blocks/action=edit?id={$block_id}", true, false);

			break;
			case "delete":
				varRequire("id");
				execWithEach($id, "polls::deleteItem");
			break;
			case "edit":

				varImport("id", "title", "question", "category", "description", "votes",
				"status", "expires", "allowcomments", "changeexpiration");

				varRequire("id", "title", "question", "category", "description", "votes");

				polls_validateOptions($description);

				$db->query("UPDATE ".db_table("polls")." SET
					title = '{$title}',
					question = '{$question}',
					category = '{$category}',
					".($changeexpiration ? "expires = '".(polls::getexpirationtime($expires))."'," : "")."
					allowcomments = '{$allowcomments}',
					status = '{$status}'
				WHERE id = '{$id}'", __FILE__, __LINE__);

				$db->query("DELETE FROM ".db_table("polls_option")."
				WHERE pollid='{$id}'", __FILE__, __LINE__);

				reset($description);
				$j = 1;
				while (list($i) = each($description)) {
					if ($description[$i]) {
						$db->query("INSERT INTO ".db_table("polls_option")." (
							id,
							pollid,
							description,
							votes,
							orderid
						) VALUES (
							'".$db->free_id("polls_option")."',
							'{$id}',
							'".$description[$i]."',
							'".$votes[$i]."',
							'".$j++."'
						)");
					}
				}

				slog("polls: modified poll '$id'", "actions", 1);
			break;
			case "create":

				varImport("title", "question", "category", "description", "votes", "status", "expires", "allowcomments");

				varRequire("title", "question", "category", "description", "votes");

				polls_validateOptions($description);

				/* creating poll */
				$db->query("
					INSERT INTO ".db_table("polls")." (
						id,
						category,
						title,
						question,
						authorid,
						created,
						expires,
						status,
						allowcomments
					) VALUES (
						'".($pollid = $db->free_id("polls"))."',
						'{$category}',
						'{$title}',
						'{$question}',
						'{$USER["id"]}',
						'".time()."',
						'".polls::getExpirationTime($expires)."',
						'{$status}',
						'{$allowcomments}'
					)
				");

				reset($description);
				$j = 1;
				while (list($i) = each($description)) {
					if ($description[$i]) {
						$db->query("INSERT INTO ".db_table("polls_option")." (
							id,
							pollid,
							description,
							votes,
							orderid
						) VALUES (
							'".$db->free_id("polls_option")."',
							'$pollid',
							'".$description[$i]."',
							'".$votes[$i]."',
							'".$j++."'
						)");
					}
				}

				slog("polls: created poll '$title'", "actions", 1);
			break;
		}
	}

	redirect($return);

	db_exit();
?>