<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"chart.lib.php", "comments", "categories", "polls"
	);

	Extract (
		URLGetArgs ("null/action=alpha?id=int&page=page")
	);

	setDefault("action", "");

	// sql category lock
	$cat_lock = "(category = '".implode("' OR category ='", Categories::fetchAllowed())."')";

	switch ($action) {
		case "view":

			if ($id) {
				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "polls/index.tpl");

				$db->query("SELECT id, category, title, question,
				authorid, created, expires, status, allowcomments
				FROM ".db_table("polls")."
				WHERE id = '{$id}' AND status = '1' AND (expires = '0' OR expires < '".time()."') AND {$cat_lock}
				",__FILE__, __LINE__);

				if ($db->num_rows()) {
				
					$row = $db->fetch_row();

					// is this poll expired?
					$expired = polls::timeExpired($row["expires"]);
				
					if ($expired || polls::alreadyVoted($id)) {

						// inserting chart instead of form
						$tpl->set("POLL_CONTENT", polls::createChart($row["id"], "220px"));
						
					} else {

						// inserting vote form
						$tpl->insert("POLL_CONTENT", "polls/vote.form.tpl");

						$p = $db->query("SELECT id, description, votes FROM ".db_table("polls_option")."
						WHERE pollid = '{$row["id"]}' ORDER BY orderid ASC", __FILE__, __LINE__, true);

						while ($opt = $db->fetch_row($p)) {
							$tpl->set_arr($opt, "OPTION");
							$tpl->saveBuff("OPTION");
						}
					}

					$tpl->set_arr ($row);

					$tpl->set_arr (
						Array (
							"BLOCK_ICON"		=> mkIcon("polls.png", 16),
							"BLOCK_TITLE"		=> _l("L_POLLS"),
							"RETURN"			=> ""
						)
					);
					$mcBuff = $tpl->make();

				} else {
					$mcBuff = "";
				}
			}
		break;
		default:
			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "polls/index.tpl");

			$pager = $db->pager (
				"SELECT id FROM ".db_table("polls")."
				WHERE status = '1' AND (expires = '0' OR expires < '".time()."') AND {$cat_lock}",
				"index.php/module=polls?page=%p", $page, conf::getkey("polls", "items_per_page")
			);

			$db->query("SELECT id, category, title, question,
			authorid, created, expires, status, allowcomments
			FROM ".db_table("polls")."
			WHERE status = '1' AND (expires = '0' OR expires < '".time()."') AND {$cat_lock}
			ORDER BY category ASC, title ASC {$pager["sql"]}",
			__FILE__, __LINE__);

			if ($db->num_rows()) {
				while ($row = $db->fetch_row()) {
					$tpl->set_arr($row, "POLL");
					$tpl->savebuff("POLL");
				}
	
				$tpl->set_arr (
					Array (
						"BLOCK_ICON"		=> mkIcon("polls.png", 16),
						"BLOCK_TITLE"		=> _l("L_POLLS"),
						"BLOCK_SUBTITLE"	=> _l("L_ACTIVE_POLLS"),
						"PAGER"				=> $pager["html"],
						"RETURN"			=> ""
					)
				);
	
				$mcBuff = $tpl->make();
			}
		break;
	}
?>