<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.lib.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	define ("GEKKO_POLLS_VOTE_INTERVAL", 60*60*24);

	Class Polls {
		function prepareBlockForDisplay(&$row) {

			$db =& $GLOBALS["db"];

			$tpl = new ContentBlock();

			$tpl->load("polls/show.block.tpl");

			// is this poll expired?
			$expired = polls::timeExpired($row["expires"]);

			if ($expired || polls::alreadyVoted($row["id"])) {

				// inserting chart instead of form
				$tpl->set("CONTENT", polls::createChart($row["id"], "90%"));

			} else {

				// inserting vote form
				$tpl->insert("CONTENT", "polls/vote.form.tpl");

				$p = $db->query("SELECT id, description, votes FROM ".db_table("polls_option")."
				WHERE pollid = '{$row["id"]}' ORDER BY orderid ASC", __FILE__, __LINE__, true);

				while ($opt = $db->fetch_row($p)) {
					$tpl->set_arr($opt, "OPTION");
					$tpl->saveBuff("OPTION");
				}
			}

			$tpl->set_arr (
				Array (
					"RETURN"	=> "",
					"ID"		=> $row["id"],
					"EXPIRED"	=> $expired ? _l("L_EXPIRED_POLL"): ""
				)
			);

			$tpl->set_arr($row);

			return $tpl->make();
		}
		function getExpirationTime($vigency) {
			return (($vigency = polls::getPossibleVigency($vigency)) > 0) ? time()+$vigency : 0;
		}
		function getExpirationDate($time) {
			return $time ? (($time > time()) ? dateFormat($time) : _l("L_POLL_HAS_EXPIRED")) : _l("L_NEVER_EXPIRES");
		}
		function timeExpired($time) {
			return $time ? (($time > time()) ? false : true): false;
		}
		function getPossibleVigency($i = false) {
			$vigency = Array (
				0 => _l("L_NEVER_EXPIRES"),
				1 => _l("L_ONE_HOUR"),
				2 => _l("L_ONE_DAY"),
				3 => _l("L_ONE_WEEK"),
				4 => _l("L_ONE_MONTH"),
				5 => _l("L_ONE_YEAR")
			);
			if ($i !== false) {
				// returns scalar value for its respective human readable vigency
				switch ($i) {
					case 0: return 0; break;
					case 1: return 3600; break;
					case 2: return 86400; break;
					case 3: return 86400*7; break;
					case 4: return 86400*30; break;
					case 5: return 86400*365; break;
				}
			}
			return $vigency;
		}
		function registerVote($id) {
			return $GLOBALS["AccessTable"]->check("polls-vote-$id",GEKKO_POLLS_VOTE_INTERVAL, 1);
		}
		function alreadyVoted($id) {
			return $GLOBALS["AccessTable"]->check("polls-vote-$id",GEKKO_POLLS_VOTE_INTERVAL, 1, false, true);
		}
		function createChart($id, $size = "80%") {

			$db =& $GLOBALS["db"];

			LoadLib ("chart.lib.php");

			$p = $db->query("SELECT description, votes FROM ".db_table("polls_option")."
			WHERE pollid = '$id' ORDER BY orderid ASC", __FILE__, __LINE__, true);

			// creating chart
			unset($chart);
			while ($opt = $db->fetch_row($p)) {
				if (!isset($chart))
					$chart = new Chart($size, true);
				$item_id = $chart->createItem($opt["description"]);
				$chart->addItemNode($item_id, $opt["votes"]);
			}
			$chart = isset($chart) ? $chart->make() : "";
			return $chart;
		}

		function allowComment($thread) {
			// Check Function Comments::allowComment();
			$q = $GLOBALS["db"]->query("SELECT id FROM ".db_table("polls")." WHERE id = '{$thread}'
			AND allowcomments = '1' AND status = '1'",
			__FILE__, __LINE__, true);
			return $GLOBALS["db"]->num_rows($q) ? true : false;
		}
		/**
		* deleteItem(item id);
		* @returns: boolean
		*
		*/
		// deletes a poll and all associated content with it
		function deleteItem($id) {

			// loading 'comments' api
			LoadLib("comments");

			// deleting comments
			Comments::deleteItems("polls", $id);

			slog("polls: deleted poll '$id'", "actions", 1);

			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("polls")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

	}
?>