<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: module.inc.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class GekkoModule_Polls {
		function create_menu() {
			return false;
		}
		function configure() {
			Conf::getKey("polls", "items_per_page", 8, "i");
			Conf::getKey("polls", "items_per_admin_page", 3, "i");
			Conf::getKey("polls", "allow_user_comments", 1, "b");
		}
		function install() {
			/*
				A friend of mine told me that table names shouldn't be named as
				plural since they are "single entities"

				This table is named as plural because "comments" module needs
				the principal table to own the same name as it's module
			*/

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("polls_option")." (
				id MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				pollid MEDIUMINT (8) UNSIGNED NOT NULL,
				description VARCHAR (128),
				votes SMALLINT (5) UNSIGNED NOT NULL,
				orderid TINYINT UNSIGNED NOT NULL
			)", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("polls")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				category SMALLINT (5) UNSIGNED NOT NULL,
				title VARCHAR (64),
				question VARCHAR (255),
				authorid MEDIUMINT (8) UNSIGNED NOT NULL,
				created INT (11) UNSIGNED NOT NULL,
				expires INT (11) UNSIGNED NOT NULL,

				status ENUM('0','1') NOT NULL default '1',

				allowcomments ENUM('0','1') NOT NULL default '1'
			)
			",__FILE__, __LINE__, true);

			modCore::registerModule($GLOBALS["cgdb"]["polls"], "polls", "*", $GLOBALS["cgdb"]["polls"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("polls"),__FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("polls_option"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];

			if (Packages::checkVersion("0.5.8", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("polls")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__, true);
			}
			if (Packages::checkVersion("0.5.9", $provided_v) < 0) {

				// this table was introduced in this version and needs to be filled
				$GLOBALS["db"]->query("
				CREATE TABLE ".db_table("polls_option")." (
					id MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
					pollid MEDIUMINT (8) UNSIGNED NOT NULL,
					description VARCHAR (128),
					votes SMALLINT (5) UNSIGNED NOT NULL,
					orderid TINYINT UNSIGNED NOT NULL
				)
				", __FILE__, __LINE__, true);


				$vote_fields = $desc_fields = Array();
				// dummy fields
				for ($i = 1; $i <= 10; $i++) {
					$vote_fields[] = "optvotes_$i";
					$desc_fields[] = "optdescr_$i";
				}

				$q = $db->query("SELECT id, category, title, description, authorid, created, expires,
				status, allowcomments, ".implode(",", $vote_fields).", ".implode(",", $desc_fields)." FROM ".db_table("polls"), __FILE__, __LINE__, true);

				while ($row = $db->fetch_row($q)) {
					$order = 1;
					for ($i = 1; $i <= 10; $i++) {
						if ($row["optdescr_$i"] || $row["optvotes_$i"]) {
							$db->query("INSERT INTO ".db_table("polls_option")." (pollid, description,
							votes, orderid) VALUES ('{$row["id"]}', '".addslashes($row["optdescr_$i"])."', '{$row["optvotes_$i"]}',
							'{$order}')", __FILE__, __LINE__, true);
							$order++;
						}
					}
				}

				// alter table
				$db->query("ALTER TABLE ".db_table("polls")."
				DROP COLUMN ".implode(", DROP COLUMN ", $vote_fields).",
				DROP COLUMN ".implode(", DROP COLUMN ", $desc_fields)."",
				__FILE__, __LINE__, true);
			}

			if (Packages::checkVersion("0.5.10", $provided_v) < 0) {
				// alter table
				$db->query("ALTER TABLE ".db_table("polls")."
				CHANGE description question VARCHAR (128) NOT NULL,
				CHANGE id id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT",
				__FILE__, __LINE__, true);
			}
		}
		function ext_uninstall($module) {

		}
	}
?>